(import pseudolists)

(import simple-tests (chicken base) (chicken condition))

'(basic?
   parameter
   (pl-parameter 0)
   pls
   (pl 0 1 2 3)
   mls
   (pl-maker 5)
   ils
   (pl-iterate add1 5 1))

(define-tester
  (basic?
    parameter
    (pl-parameter 0)
    pls
    (pl 0 1 2 3)
    mls
    (pl-maker 5)
    ils
    (pl-iterate add1 5 1))
  (pl-parameter)
  0
  (pl-data pls)
  '(0 1 2 3 . 0)
  (pl-data mls)
  '(0 0 0 0 0 . 0)
  (pl-data ils)
  '(1 2 3 4 5 . 0)
  (pl? pls)
  #t
  (pl? mls)
  #t
  (pl? ils)
  #t
  (pl? '(0 1 2 3))
  #f
  ((pl-of? 0) pls)
  #t
  ((pl-of? '()) mls)
  #f
  (pl-car mls)
  0
  (pl-at 3 mls)
  0
  (pl-at 3 pls)
  3
  (pls 3)
  3
  (pl-head pls)
  '(0 1 2 3)
  (pls)
  '(0 1 2 3)
  (pl-tail pls)
  0
  (pl-data pls)
  '(0 1 2 3 . 0)
  (pl-data mls)
  '(0 0 0 0 0 . 0)
  (pl-tail mls)
  0
  (pl-data ils)
  '(1 2 3 4 5 . 0)
  (ils)
  '(1 2 3 4 5)
  (pl-tail ils)
  0
  (pl-head (pl-cons -1 pls))
  '(-1 0 1 2 3)
  (pl-head (pl-cdr pls))
  '(1 2 3)
  (pl-set! 0 1 mls)
  (void)
  (pl-at 0 mls)
  1
  (pl-set! 1 2 mls)
  (void)
  (pl-at 1 mls)
  2
  (mls 1)
  2
  (mls 2 3)
  (void)
  (mls 2)
  3
  (mls)
  '(1 2 3 0 0)
  (pl-head mls)
  '(1 2 3 0 0))

(newline)

'(checked? parameter (pl-parameter (pl-checker integer?)) pls (pl 0 1 2 3))

(define-tester
  (checked? parameter (pl-parameter (pl-checker integer?)) pls (pl 0 1 2 3))
  (pl-tail pls)
  (pl-parameter)
  (pl-head pls)
  '(0 1 2 3)
  (condition-case (pl 0 1 #f 3) ((exn) #f))
  #f
  (condition-case (pl-set! 0 #f pls) ((exn) #f))
  #f
  (pl-set! 0 100 pls)
  (void)
  (pl-car pls)
  100
  (pls 0 10)
  (void)
  (pls 0)
  10)

(newline)

'(ops? parameter
       (pl-parameter 0)
       pls
       (pl 0 1 2 3)
       mls
       (pl-maker 5)
       ils
       (pl-iterate add1 5 1)
       ii
       (pl-iterate add1 5))

(define-tester
  (ops? parameter
        (pl-parameter 0)
        pls
        (pl 0 1 2 3)
        mls
        (pl-maker 5)
        ils
        (pl-iterate add1 5 1)
        ii
        (pl-iterate add1 5))
  (pl-parameter)
  0
  (pl-data pls)
  '(0 1 2 3 . 0)
  (pl-data mls)
  '(0 0 0 0 0 . 0)
  (pl-data ils)
  '(1 2 3 4 5 . 0)
  (pl-data (ii 1))
  '(1 2 3 4 5 . 0)
  (pls)
  '(0 1 2 3)
  (pl? pls)
  #t
  ((pl-of? 1) pls)
  #f
  ((pl-of? 0) pls)
  #t
  ((pl-of? 0 integer?) pls)
  #t
  ((pl-of? 0 integer? positive?) pls)
  #f
  (pl? '(0 1 2 3 . 0))
  #f
  (pl-at 0 pls)
  0
  (pl-at 3 pls)
  3
  (pl-head (pl-map add1 pls))
  '(1 2 3 4)
  (pl-head (pl-map + pls pls))
  '(0 2 4 6)
  (pl-index negative? pls)
  -1
  (pl-index odd? pls)
  1
  (pl-head (pl-filter odd? pls))
  '(1 3)
  (receive (_ pl-no) (pl-filter odd? pls) (pl-head pl-no))
  '(0 2)
  (pl-head (pl-append pls ils))
  '(0 1 2 3 1 2 3 4 5)
  (pl-head (pl-append pls ils mls))
  '(0 1 2 3 1 2 3 4 5 0 0 0 0 0)
  (pl-set! 2 20 pls)
  (void)
  (pl-head pls)
  '(0 1 20 3)
  (pl-length pls)
  4
  (pl-tail pls)
  0
  (pl-at 2 pls)
  20
  (pl-head pls)
  '(0 1 20 3)
  (pl-head (pl-drop 3 pls))
  '(3)
  (pl-head (pl-drop-while zero? pls))
  '(1 20 3)
  (pl-head (pl-drop-while (cut <= <> 10) pls))
  '(20 3)
  (pl-head (pl-take 3 pls))
  '(0 1 20)
  (pl-head (pl-take-while (cut <= <> 10) pls))
  '(0 1)
  (pl-head (pl-reverse pls))
  '(3 20 1 0)
  (pl-head (pl-memp (lambda (x) (> x 10)) pls))
  '(20 3)
  (pl-head mls)
  '(0 0 0 0 0)
  ((pl-of? 0 zero?) mls)
  #t
  (pl-length mls)
  5
  (pl-set! 2 20 mls)
  (void)
  (pl-head mls)
  '(0 0 20 0 0)
  (pl-tail mls)
  0
  (pl? mls)
  #t
  (pl-head (pl-maker 5 1))
  '(1 1 1 1 1)
  (pl? ils)
  #t
  (pl-head ils)
  '(1 2 3 4 5)
  (pl-tail ils)
  0
  (pl-at 2 ils)
  3
  (pl? ii)
  #f
  (pl? (ii 1))
  #t
  (pl-length (ii 1))
  5
  (pl-at 3 (ii 1))
  4
  (pl-head (pl-map * (pl 0 1 2 3) (pl 10 20)))
  '(0 20)
  (condition-case
    (pl-map
      +
      (parameterize ((pl-parameter #f)) (pl 0 1 2 3))
      (parameterize ((pl-parameter #t)) (pl 0 1 2 3)))
    ((exn) #f))
  #f)

(newline)

'(new-ops? parameter (pl-parameter 0) pls (pl 0 1 2 3 4 5))

(define-tester
  (new-ops? parameter (pl-parameter 0) pls (pl 0 1 2 3 4 5))
  (pl-data pls)
  '(0 1 2 3 4 5 . 0)
  (pl-fold-right + 0 pls)
  15
  (pl-fold-left + 0 pls)
  15
  (pl-fold-right0 + pls)
  15
  (pl-fold-left0 + pls)
  15
  (pl-head (pl-fold-right pl-cons (pl) pls))
  '(0 1 2 3 4 5)
  (pl-fold-right cons '() pls)
  '(0 1 2 3 4 5)
  (pl-head (pl-adjoin 3 pls))
  '(0 1 2 3 4 5)
  (pl-head (pl-adjoin #f pls))
  '(#f 0 1 2 3 4 5)
  (pl-head (pl-remove-dups pls))
  '(0 1 2 3 4 5)
  (pl-head (pl-remove-dups (pl 0 1 0 1 0 1)))
  '(0 1)
  (pl-flat? pls)
  #t
  (pl-flat? (pl 0 (pl 1 (pl 2))))
  #f
  (pl-head (pl-flatten (pl 1 2 3)))
  '(1 2 3)
  (pl-head (pl-flatten (pl 1 '(2 3))))
  '(1 (2 3))
  (pl-head (pl-flatten (pl 1 (pl 2 3))))
  '(1 2 3)
  (pl-head (pl-flatten (pl 1 (pl 2 3) (pl 4 5) 6)))
  '(1 2 3 4 5 6)
  (pl-head (pl-flatten (pl 1 (pl 2 (pl 3)))))
  '(1 2 3)
  (pl-head (pl-flatten (pl 1 (pl 2 (pl 3 (pl 4)) 5) 6)))
  '(1 2 3 4 5 6)
  (condition-case
    (pl-flatten (pl 1 (parameterize ((pl-parameter #f)) (pl 2 3))))
    ((exn) #f))
  #f)

(newline)

(define-tester
  (collect?)
  (pl-data (pl-collect (add1 x) (x (pl 0 1 2 3))))
  '(1 2 3 4 . 0)
  (pl-data (pl-collect (add1 x) (x (pl 0 1 2 3))))
  '(1 2 3 4 . 0)
  (pl-data (pl-collect x (x (pl 0 1 2 3 4 5) (odd? x))))
  '(1 3 5 . 0)
  (pl-data (pl-collect x (x (pl 0 1 2 3 4 5) (odd? x))))
  '(1 3 5 . 0)
  (pl-data (pl-collect (* 10 n) (n (pl 0 1 2 3 4 5) (positive? n) (even? n))))
  '(20 40 . 0)
  (pl-data (pl-collect (list c k) (c (pl 'A 'B 'C)) (k (pl 1 2 3 4))))
  '((A 1)
    (A 2)
    (A 3)
    (A 4)
    (B 1)
    (B 2)
    (B 3)
    (B 4)
    (C 1)
    (C 2)
    (C 3)
    (C 4)
    .
    0))

(newline)

(test-all PSEUDOLISTS
  basic?
  checked?
  ops?
  new-ops?
  collect?
  )
